DB=$1
COUNT=$2

dropdb --if-exists test
createdb test

psql $DB -c 'CREATE TABLE t1 (a int primary key)';
psql $DB -c 'CREATE TABLE t2 (a int references t1)';

for i in `seq 1 $COUNT`; do
	psql $DB -c "CREATE TABLE x_$i (a int references t1)";
	psql $DB -c "CREATE TABLE y_$i (a int primary key)";

	psql $DB -c "ALTER TABLE t1 ADD FOREIGN KEY (a) REFERENCES y_$i";
	psql $DB -c "ALTER TABLE t2 ADD FOREIGN KEY (a) REFERENCES y_$i";
done

psql $DB -c 'CREATE TABLE t3 (a int primary key)';
psql $DB -c 'CREATE TABLE t4 (a int primary key)';

for i in `seq 1 $COUNT`; do
    psql $DB -c "ALTER TABLE t3 ADD FOREIGN KEY (a) REFERENCES t4"
    psql $DB -c "ALTER TABLE t4 ADD FOREIGN KEY (a) REFERENCES t3"
done


psql $DB -c 'CREATE TABLE t5 (a int, b int, c int, d int, primary key (a,b,c,d))';
psql $DB -c 'CREATE TABLE t6 (a int, b int, c int, d int, foreign key (a,b,c,d) references t5)';

for i in `seq 1 $COUNT`; do
	psql $DB -c "CREATE TABLE p_$i (a int, b int, c int, d int, foreign key (a,b,c,d) references t5)";
	psql $DB -c "CREATE TABLE q_$i (a int, b int, c int, d int, primary key (a,b,c,d))";

	psql $DB -c "ALTER TABLE t5 ADD FOREIGN KEY (a,b,c,d) REFERENCES q_$i";
	psql $DB -c "ALTER TABLE t6 ADD FOREIGN KEY (a,b,c,d) REFERENCES q_$i";
done

psql $DB -c 'CREATE TABLE t7 (a int, b int, c int, d int, primary key (a,b,c,d))';
psql $DB -c 'CREATE TABLE t8 (a int, b int, c int, d int, primary key (a,b,c,d))';

for i in `seq 1 $COUNT`; do
    psql $DB -c "ALTER TABLE t7 ADD FOREIGN KEY (a,b,c,d) REFERENCES t8"
    psql $DB -c "ALTER TABLE t8 ADD FOREIGN KEY (a,b,c,d) REFERENCES t7"
done

psql $DB -c "ANALYZE"
